Process CanBePrefix and drop Selectors

01/13/2019 03:38 PM - Junxiao Shi

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Junxiao Shi % Done: 100%

Category: Tables Estimated time: 9.00 hours

Target version: v0.7   

Description

In PIT and CS, process Interest CanBePrefix element and stop processing deprecated Selectors.

This includes necessary adjustments to PIT structure, as well as deleting old test cases.

Related issues:

Blocks ndn-cxx - Feature #4567: Encode Interest into v0.3 format and drop sup... Closed

History

#1 - 01/13/2019 03:38 PM - Junxiao Shi

- Blocked by Feature #4567: Encode Interest into v0.3 format and drop support for v0.2 format added

#2 - 01/13/2019 03:40 PM - Junxiao Shi

- Description updated

#3 - 04/11/2019 05:58 AM - Junxiao Shi

- Status changed from New to In Progress

- Assignee set to Junxiao Shi

#4 - 04/11/2019 06:47 AM - Junxiao Shi

https://gerrit.named-data.net/5399 eliminates Selectors from CS tests; it also promotes FindFixture to CsFixture for simplifying CS policy tests.

Rationale for changes in TestCs/Find suite:

EmptyInterestName: deleting because zero-component Interest name is forbidden by spec

ExactName: spliting to ExactName (CanBePrefix=false) and ExactName_Cbp (CanBePrefix=true)

EmptyDataName: changing to FullName_EmptyDataName with implicit digest included in Interest name, because zero-component Interest

name is forbidden by spec

Leftmost: renaming to PrefixName and adding CanBePrefix=true; also creating PrefixName_NoCbp with CanBePrefix=false

Rightmost, MinSuffixComponent, MaxSuffixComponent, DigestOrder, DigestExclude: deleting because Selectors are gone

#5 - 04/16/2019 05:50 AM - Junxiao Shi

https://gerrit.named-data.net/5402 stops processing ChildSelector in CS implementation. It also converts some function objects into template

arguments for better performance.

Processing of other Selectors comes from Interest::matchesData that belongs to #4913.

#6 - 04/16/2019 05:50 AM - Junxiao Shi

- % Done changed from 0 to 50

#7 - 04/16/2019 08:21 AM - Junxiao Shi

Currently, I'm simply removing ChildSelector processing without further optimization.

I recognize the opportunity of reducing "prefix range" when CanBePrefix is unset, but I'd defer that to #4914.

#8 - 04/19/2019 08:18 AM - Junxiao Shi

From https://gerrit.named-data.net/5402:

code is fine but this should be merged after #4916

 I disagree. According to 0.6.5 release notes:

02/12/2026 1/2

https://gerrit.named-data.net/5399
https://gerrit.named-data.net/5402
https://redmine.named-data.net/issues/4913
https://redmine.named-data.net/issues/4914
https://gerrit.named-data.net/5402
https://redmine.named-data.net/issues/4916
https://named-data.net/doc/NFD/0.6.5/RELEASE_NOTES.html


Note that this is the last release that encodes to NDN packet format version 0.2.1. A future release will continue to decode v0.2.1 format, but will

encode to v0.3 format.

 There's no need to wait for any more releases.

#9 - 05/07/2019 12:28 PM - Junxiao Shi

- % Done changed from 50 to 70

https://gerrit.named-data.net/5443 eliminates Selectors from PIT tests.

#10 - 05/08/2019 09:27 AM - Junxiao Shi

- Status changed from In Progress to Code review

- % Done changed from 70 to 100

Given the changes needed to drop Selectors processing in PIT is minimal, they are now part of Change 5443.

There are a lot of optimization possible after these changes, but they should belong to another issue.

#11 - 05/09/2019 09:48 AM - Junxiao Shi

- Blocked by deleted (Feature #4567: Encode Interest into v0.3 format and drop support for v0.2 format)

#12 - 05/15/2019 01:50 PM - Junxiao Shi

- Status changed from Code review to Closed

#13 - 07/20/2019 11:57 AM - Davide Pesavento

- Blocks Feature #4567: Encode Interest into v0.3 format and drop support for v0.2 format added
